#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <conio.h>
#include <stdlib.h>
#include <fstream>
#include <iostream>



unsigned char charlet[5][8][256];

unsigned char cselect = 0;
unsigned char cy = 0;
unsigned char cx = 0;

unsigned char binline(unsigned char binrow) {
	unsigned char h=0;
	for (int i = 0; i <= 4; i++) {
		h = h << 1;
		if (charlet[i][binrow][cselect] > 0) {
			h += 1;
		}
	}
	return h;
}

void printbin(unsigned char t) {
	if (t & 0x80) { wprintf(L"1"); }
	else { wprintf(L"0"); }
	if (t & 0x40) { wprintf(L"1"); }
	else { wprintf(L"0"); }
	if (t & 0x20) { wprintf(L"1"); }
	else { wprintf(L"0"); }
	if (t & 0x10) { wprintf(L"1"); }
	else { wprintf(L"0"); }
	if (t & 0x08) { wprintf(L"1"); }
	else { wprintf(L"0"); }
	if (t & 0x04) { wprintf(L"1"); }
	else { wprintf(L"0"); }
	if (t & 0x02) { wprintf(L"1"); }
	else { wprintf(L"0"); }
	if (t & 0x01) { wprintf(L"1"); }
	else { wprintf(L"0"); }
}

void screenprint() {
	system("CLS");
	_setmode(_fileno(stdout), _O_U16TEXT);
	wprintf(L"char: %d \t", cselect);
	printbin(cselect);
	wprintf(L"\npos: %d, %d\n", cx, cy);
	wprintf(L"\x250c\x2500\x2500\x2500\x2500\x2500\x2500\x2500\x2500\x2500\x2500\x2510\n"); //top of frame
	unsigned char cselected = 0;
	for (int j = 0; j <= 7; j++) {
		wprintf(L"\x2502");
		for (int i = 0; i <= 4; i++) {
			if (i == cx && j == cy) { cselected = 2; } else { cselected = 0; }
			switch (charlet[i][j][cselect]+cselected){
				case 1:
					wprintf(L"\x2588\x2588"); //light cell
					break;
				case 2:
					wprintf(L"--"); //selected+dark
					break;
				case 3:
					wprintf(L"\x2592\x2592"); //selected+light
					break;
				default:
					wprintf(L"  "); //dark cell
					break;
			}
		}
		wprintf(L"\x2502  %x\n",binline(j));
	}

	wprintf(L"\x2514\x2500\x2500\x2500\x2500\x2500\x2500\x2500\x2500\x2500\x2500\x2518\n"); //bottom of frame
}

void writenfile() {
	std::ofstream cfile("data.bin", std::ofstream::binary);
	for (int ichar = 0; ichar <= 127; ichar++) {
		for (int irow = 0; irow <= 7; irow++) {
			unsigned char temp = 0;
			for (int icol = 0; icol <= 4; icol++) {
				temp = temp << 1;
				if (charlet[icol][irow][ichar] > 0) {
					temp += 1;
				}
			}
			cfile.write((char*)&temp, sizeof(unsigned char));
		}
	}
	cfile.close();
}

void readnfile() {
	std::ifstream cfile("data.bin", std::ifstream::binary);
	for (int ichar = 0; ichar <= 127; ichar++) {
		for (int irow = 0; irow <= 7; irow++) {
			unsigned char temp = 0;
			cfile.read((char*)&temp, sizeof(unsigned char));
			for (int icol = 0; icol <= 4; icol++) {
				if (((temp>>(4-icol))&1) >= 1) {
					charlet[icol][irow][ichar] = 1;
				}
				else {
					charlet[icol][irow][ichar] = 0;
				}
			}
		}
	}
	cfile.close();
}

int main()
{
	int k = 0;
	while (k!='q') {
		screenprint();
		k = 0;
		while (k == 0) {
			k = _getch();
		}
		switch (k) {
			case 'j': cx--;  break;
			case 'l': cx++;  break;
			case 'k': cy++;  break;
			case 'i': cy--;  break;
			case ' ': if (charlet[cx][cy][cselect] != 0) { charlet[cx][cy][cselect] = 0; } else { charlet[cx][cy][cselect] = 1; }	break;
			case 'c': 
				charlet[cx][cy][cselect] = 0;
				cx++;
				if (cx == 5) { cx = 0; cy++; }
				if (cy == 8) { cy = 0; }
				break;
			case 'v':
				charlet[cx][cy][cselect] = 1;
				cx++;
				if (cx == 5) { cx = 0; cy++; }
				if (cy == 8) { cy = 0; }
				break;
			case 'n':
				cselect++;
				break;
			case 'p':
				cselect--;
				break;
			case 's':
				writenfile();
				break;
			case 'o':
				readnfile();
				break;
		}
		if (cx >= 255) { cx = 0; }
		if (cx >= 4) { cx = 4; }
		if (cy >= 255) { cy = 0; }
		if (cy >= 7) { cy = 7; }

	}
	return 0;
}

